<template>
  <div
    v-if="issPositionData?.latitude && issPositionData?.longitude"
    ref="mapContainer"
    class="m-10 rounded-xl flex flex-1 map-container"
  ></div>

  <div v-else class="m-10 rounded-xl flex flex-1 map-container">
    <div class="flex flex-1 justify-center items-center">
      <div class="text-2xl">No ISS position data available</div>
    </div>
  </div>
</template>

<script setup lang="ts">
import type { FeatureCollection, Geometry, GeoJsonProperties } from "geojson";
import mapboxgl from "mapbox-gl";
import MapboxDraw from "@mapbox/mapbox-gl-draw";

const runtimeConfig = useRuntimeConfig();
mapboxgl.accessToken = runtimeConfig.public.mapboxToken as string;
const mapContainer = ref<HTMLElement | null>(null);

const { issPositionData, issPositionRefresh } = await useIssPosition();
const useRetrievedGeojson = useRetrievedGeojsonState();

const savedGeojson = useSavedGeojson();
const appConfig = useAppConfig();

let map: mapboxgl.Map;
let marker: mapboxgl.Marker;

var Draw = new MapboxDraw({
  displayControlsDefault: false,

  controls: {
    polygon: true,
    trash: true,
  },
  defaultMode: "draw_polygon",
});

let pointsData: FeatureCollection<Geometry, GeoJsonProperties> = {
  type: "FeatureCollection",
  features: [],
};

watch(useRetrievedGeojson, (data) => {
  const toJson = JSON.parse(data);

  const e = Draw.add(toJson);
});

watch(issPositionData, (data, prevData) => {
  if (
    data?.latitude &&
    data?.longitude &&
    data.latitude !== prevData?.latitude &&
    data.longitude !== prevData?.longitude
  ) {
    marker.setLngLat([data.longitude, data.latitude]);
    map.setCenter([data.longitude, data.latitude]);

    pointsData.features.push({
      type: "Feature",
      geometry: {
        type: "Point",
        coordinates: [data.longitude, data.latitude],
      },
      properties: {},
    });

    const daylightSource = map.getSource(
      "daylight-iss-points"
    ) as mapboxgl.GeoJSONSource;
    const eclipseSource = map.getSource(
      "eclipse-iss-points"
    ) as mapboxgl.GeoJSONSource;

    if (data.visibility === "daylight") {
      daylightSource.setData(pointsData);
    } else {
      eclipseSource.setData(pointsData);
    }
  }
});

onMounted(() => {
  map = new mapboxgl.Map({
    container: mapContainer.value as HTMLElement,
    style: "mapbox://styles/mapbox/navigation-night-v1",
    center: [
      issPositionData.value?.longitude!,
      issPositionData.value?.latitude!,
    ],
    zoom: 3,
  });

  map.addControl(Draw, "top-right");

  const svg = document.createElement("svg");
  svg.innerHTML =
    '<img src="/satelite.svg" alt="ISS" width="50" height="50" />';

  marker = new mapboxgl.Marker(svg);

  marker
    .setLngLat([
      issPositionData.value?.longitude!,
      issPositionData.value?.latitude!,
    ])
    .addTo(map);

  map.setCenter([
    issPositionData.value?.longitude!,
    issPositionData.value?.latitude!,
  ]);

  map.on("load", function () {
    map.addSource("daylight-iss-points", {
      type: "geojson",
      data: {
        type: "FeatureCollection",
        features: [],
      },
    });

    map.addSource("eclipse-iss-points", {
      type: "geojson",
      data: {
        type: "FeatureCollection",
        features: [],
      },
    });

    map.addLayer({
      id: "point-animation",
      type: "circle",
      source: "daylight-iss-points",
      paint: {
        "circle-radius": 6,
        "circle-color": "#fbbf24",
      },
    });

    map.addLayer({
      id: "points",
      type: "circle",
      source: "eclipse-iss-points",
      paint: {
        "circle-radius": 6,
        "circle-color": "#047857",
      },
    });
  });

  map.on("draw.create", (e) => {
    const geojson = JSON.stringify(Draw.getAll());
    savedGeojson.value = geojson;
  });

  map.on("draw.update", (e) => {
    const geojson = JSON.stringify(Draw.getAll());
    savedGeojson.value = geojson;
  });

  map.on("draw.delete", (e) => {
    const geojson = JSON.stringify(Draw.getAll());
    savedGeojson.value = geojson;
  });

  setInterval(() => {
    issPositionRefresh();
  }, appConfig.refreshInterval);
});
</script>

<style scoped>
.calculation-box {
  height: 75px;
  width: 150px;
  position: absolute;
  bottom: 40px;
  left: 10px;
  background-color: rgba(255, 255, 255, 0.9);
  padding: 15px;
  text-align: center;
}
</style>
